#include "pg.h"
//#define write(variable) memcpy(header+count,&(variable),sizeof(variable))
//__attribute__((packed));

char mWriteBitMap(tImage img,char* vFile) {

	FILE* bitmap;
	if ((bitmap = fopen (vFile,"wb"))==NULL) return 0;

	unsigned long int filesize=((img.size+1)/2+118);
	unsigned long int width=img.width;
	unsigned long int height=img.height;

	unsigned char header[]={
		'B','M',
		0x22,0x22,0x22,0x22,
		0,0,0,0,
		0x76,0,0,0,

		40,0,0,0,
		0x22,0x22,0,0,
		0x22,0x22,0,0,
		1,0,
		4,0,
		0,0,0,0,
		0,0,0,0,
		0xE8,0x03,0,0,
		0xE8,0x03,0,0,
		0x10,0,0,0,
		0,0,0,0,

		0x22,0x22,0x22,0,
		0x22,0x22,0x22,0,
		0x22,0x22,0x22,0,
		0x22,0x22,0x22,0,
		0x22,0x22,0x22,0,
		0x22,0x22,0x22,0,
		0x22,0x22,0x22,0,
		0x22,0x22,0x22,0,
		0x22,0x22,0x22,0,
		0x22,0x22,0x22,0,
		0x22,0x22,0x22,0,
		0x22,0x22,0x22,0,
		0x22,0x22,0x22,0,
		0x22,0x22,0x22,0,
		0x22,0x22,0x22,0,
		0x22,0x22,0x22,0
	};

	header[2]=filesize;
	header[3]=filesize>>8;
	header[4]=filesize>>16;
	header[5]=filesize>>24;

	header[18]=width;
	header[19]=width>>8;

	header[22]=height;
	header[23]=height>>8;



//BEGIN of format writing

#if 0

/*
Header 14 bytes Windows Structure: BITMAPFILEHEADER
	Signature 2 bytes 'BM'
	FileSize 4 bytes File size in bytes
	reserved 4 bytes unused (=0)
	DataOffset 4 bytes File offset to Raster Data
*/

//Write header
write('B');
write('M');
write((unsigned long int)((img.size+1)/2+118));
write((unsigned long int)0);
write((unsigned long int)118);

/*
InfoHeader 40 bytes Windows Structure: BITMAPINFOHEADER
	Size 4 bytes Size of InfoHeader =40
	Width 4 bytes Bitmap Width
	Height 4 bytes Bitmap Height
	Planes 2 bytes Number of Planes (=1)
	BitCount 2 bytes Bits per Pixel
		1 = monochrome palette. NumColors = 1
		4 = 4bit palletized. NumColors = 16
		8 = 8bit palletized. NumColors = 256
		16 = 16bit RGB. NumColors = 65536 (?)
		24 = 24bit RGB. NumColors = 16M
	Compression 4 bytes Type of Compression
		0 = BI_RGB   no compression
		1 = BI_RLE8 8bit RLE encoding
		2 = BI_RLE4 4bit RLE encoding
	ImageSize 4 bytes (compressed) Size of Image
		It is valid to set this =0 if Compression = 0
	XpixelsPerM 4 bytes horizontal resolution: Pixels/meter
	YpixelsPerM 4 bytes vertical resolution: Pixels/meter
	ColorsUsed 4 bytes Number of actually used colors
	ColorsImportant 4 bytes Number of important colors
		0 = all
*/

//Write InfoHeader

write((unsigned long int)40);
write((unsigned long int)img.width);
write((unsigned long int)img.height);
write((unsigned short int)1);
write((unsigned short int)4);
write((unsigned long int)0);
write((unsigned long int)0);
write((unsigned short int)1000);
write((unsigned short int)1000);
write((unsigned short int)16);
write((unsigned long int)0);

/*
ColorTable 4 * NumColors bytes present only if Info.BitsPerPixel <= 8 colors should be ordered by importance
	Red 1 byte Red intensity
	Green 1 byte Green intensity
	Blue 1 byte Blue intensity
	reserved 1 byte unused (=0)
repeated NumColors times
*/
#endif
//Write ColorTable

char b;
char c;
for (char a=0;a<16;a++) {
	b=a*3;
	c=a<<2;
	header[54+c]=(img.pal[b+2])*4;   //Red
	header[55+c]=(img.pal[b+1])*4; //Green
	header[56+c]=(img.pal[b])*4; //Blue
}

/*
Raster Data Info.ImageSize bytes The pixel data
*/

//Write Image

fwrite(header,118,1,bitmap);
fwrite(img.pix,(img.size)/2,1,bitmap);

//END of format writing

	fclose(bitmap);
	return 1;
}

